From a2865529bf12952f9db5bf6f6f171be68b73b151 Mon Sep 17 00:00:00 2001
From: Francois Andrieu <darknao@fedoraproject.org>
Date: Feb 20 2022 00:33:34 +0000
Subject: [PATCH 83/88] detect latest fedora version and build redirect from it


---

diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
index 2679a1d..a55ba97 100755
--- a/build-scripts/rebuild-site.py
+++ b/build-scripts/rebuild-site.py
@@ -17,7 +17,17 @@
 #
 
 
-import tempfile, yaml, os, errno, subprocess, copy, datetime, shutil, sys, glob
+import tempfile
+import yaml
+import os
+import errno
+import subprocess
+import copy
+import datetime
+import shutil
+import sys
+import glob
+import re
 
 
 def get_config():
@@ -274,15 +284,28 @@ def init_git_repo(path):
     subprocess.run(["git", "config", "user.email", "you@example.com"], cwd=path)
     subprocess.run(["git", "commit", "--allow-empty", "-m", "init"], cwd=path)
 
+def get_version_from_file(index_file):
+    latest = None
+    if os.path.isfile(index_file):
+      with open(index_file, 'r') as f:
+        for l in f:
+          m = re.search(r'data-version="(f\d+)"', l)
+          if m:
+            latest = m[1]
+            break
+    return latest
+
+
 def gen_redirect(lang, results_dir):
     htaccess = os.path.join(results_dir, ".htaccess")
-    latest = "f35"
-    htaccess_content = f"""
-      ErrorDocument 404 /{lang}/404.html
-      Redirect 302 /{lang}/fedora/{latest} /{lang}/fedora/latest
-      """
-    with open(htaccess, "w") as file:
-        file.write(htaccess_content)
+    latest = get_version_from_file(f"{results_dir}/fedora/latest/index.html")
+    if latest:
+      htaccess_content = f"""
+        ErrorDocument 404 /{lang}/404.html
+        Redirect 302 /{lang}/fedora/{latest} /{lang}/fedora/latest
+        """
+      with open(htaccess, "w") as file:
+          file.write(htaccess_content)
 
 def main():
     config = get_config()

